(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReduxRequestsFetch"] = factory();
	else
		root["ReduxRequestsFetch"] = factory();
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/fetch-api-driver.js":
/*!*********************************!*\
  !*** ./src/fetch-api-driver.js ***!
  \*********************************/
/*! namespace exports */
/*! export createDriver [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__, __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createDriver": () => /* binding */ createDriver
/* harmony export */ });
/* harmony import */ var _helpers__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./helpers */ "./src/helpers.js");
function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }


var responseTypes = ['arraybuffer', 'blob', 'formData', 'json', 'text', null];

var getData = function getData(response, responseType) {
  if (responseType === null) {
    return Promise.resolve(null);
  }

  return response[responseType]();
};

var getResponse = function getResponse(response, responseType) {
  if (responseTypes.indexOf(responseType) === -1) {
    throw new Error("responseType must be one of the following: 'arraybuffer', 'blob', 'formData', 'json', 'text', null");
  }

  return getData(response, responseType).then(function (data) {
    return {
      data: data,
      status: response.status,
      headers: response.headers
    };
  });
};

var DummyAbortController = /*#__PURE__*/function () {
  function DummyAbortController() {}

  var _proto = DummyAbortController.prototype;

  /* eslint-disable-next-line class-methods-use-this */
  _proto.abort = function abort() {};

  return DummyAbortController;
}();

var createDriver = function createDriver(fetchInstance, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$baseURL = _ref.baseURL,
      baseURL = _ref$baseURL === void 0 ? '' : _ref$baseURL,
      _ref$AbortController = _ref.AbortController,
      AbortController = _ref$AbortController === void 0 ? DummyAbortController : _ref$AbortController;

  return function (_ref2) {
    var url = _ref2.url,
        _ref2$responseType = _ref2.responseType,
        responseType = _ref2$responseType === void 0 ? 'json' : _ref2$responseType,
        requestConfig = _objectWithoutPropertiesLoose(_ref2, ["url", "responseType"]);

    var abortSource = new AbortController();
    var responsePromise = fetchInstance((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.isAbsoluteURL)(url) ? url : baseURL + url, _extends({
      signal: abortSource.signal
    }, requestConfig)).then(function (response) {
      if (response.ok) {
        return getResponse(response, responseType);
      }

      return response.json().then(function (data) {
        response.data = data;
        throw response;
      }, function () {
        throw response;
      });
    })["catch"](function (error) {
      if ((0,_helpers__WEBPACK_IMPORTED_MODULE_0__.isNativeAbortError)(error)) {
        throw 'REQUEST_ABORTED';
      }

      throw error;
    });

    responsePromise.cancel = function () {
      return abortSource.abort();
    };

    return responsePromise;
  };
};

/***/ }),

/***/ "./src/helpers.js":
/*!************************!*\
  !*** ./src/helpers.js ***!
  \************************/
/*! namespace exports */
/*! export isAbsoluteURL [provided] [no usage info] [missing usage info prevents renaming] */
/*! export isNativeAbortError [provided] [no usage info] [missing usage info prevents renaming] */
/*! other exports [not provided] [no usage info] */
/*! runtime requirements: __webpack_require__.r, __webpack_exports__, __webpack_require__.d, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "isNativeAbortError": () => /* binding */ isNativeAbortError,
/* harmony export */   "isAbsoluteURL": () => /* binding */ isAbsoluteURL
/* harmony export */ });
// a real browser will throw an instance of `DomException`, polyfills an instance of `AbortError`
// https://developer.mozilla.org/en-US/docs/Web/API/AbortController#examples
// old browsers would set the exception `code` property equal to DOMException.ABORT_ERR
// https://developer.mozilla.org/en-US/docs/Web/API/DOMException/code
var isNativeAbortError = function isNativeAbortError(err) {
  return ['DOMException', 'AbortError'].includes(err.constructor.name) && (err.name === 'AbortError' || err.code === DOMException.ABORT_ERR);
}; // taken from https://github.com/axios/axios/blob/v1.x/lib/helpers/isAbsoluteURL.js

var isAbsoluteURL = function isAbsoluteURL(url) {
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
};

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/*! namespace exports */
/*! export createDriver [provided] [maybe used in main (runtime-defined)] [usage prevents renaming] -> ./src/fetch-api-driver.js .createDriver */
/*! other exports [not provided] [maybe used in main (runtime-defined)] */
/*! runtime requirements: __webpack_require__, __webpack_exports__, __webpack_require__.d, __webpack_require__.r, __webpack_require__.* */
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "createDriver": () => /* reexport safe */ _fetch_api_driver__WEBPACK_IMPORTED_MODULE_0__.createDriver
/* harmony export */ });
/* harmony import */ var _fetch_api_driver__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./fetch-api-driver */ "./src/fetch-api-driver.js");


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		if(__webpack_module_cache__[moduleId]) {
/******/ 			return __webpack_module_cache__[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => Object.prototype.hasOwnProperty.call(obj, prop)
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	// module exports must be returned from runtime so entry inlining is disabled
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__("./src/index.js");
/******/ })()
;
});
//# sourceMappingURL=redux-requests-fetch.js.map